!> \file output_green_mod-0.4.f90
!! Module d'ecriture des output
!<

!> \namespace output_greenmint_mod
!! Module d'ecriture des output
!! \author ...
!! \date ...
!! @note Used module
!! @note   - use module3D_phy
!<

module  output_greenmint_mod

use module3d_phy


implicit none
      

real ::  bmean                        !< bilan de masse moyen
real ::  accmean                      !< accumulation moyenne
real ::  ablmean                      !< ablation moyenne
real ::  calvmean                     !< moyenne calving
real ::  ablbordmean                  !< ablation sur les bords
real ::  bmeltmean                    !< moyenne fusion basale
real ::  tbmean                       !< temperature basale moyenne
real ::  vsmean                       !< vitesse de surface moyenne
real ::  hdotmean                     !< moyenne derivee / temps de h
real ::  bdotmean                     !< moyenne bedrock derive / temps
real ::  volf                         !< volume au dessus de la flottaison
real ::  volg                         !< volume glace posee
real ::  vol_shelf                    !< volume ice shelf
integer :: npg                        !< nombre de points englaces-poses
integer :: nf                         !< nombre de points englaces-flottants
integer :: nabl                       !< nombre de points zone d'ablation


CONTAINS

subroutine init_outshort

ndisp=100                             ! ndisp sortie courte tous les ndisp

end subroutine init_outshort



!_________________________________________________________________________
subroutine shortoutput

! 1_initialization
!------------------
real ::  smax                         ! pour calculer la surface  max
real ::  hmax                         ! pour calculer l'epaisseur max
     
npg=0
nf=0
nabl=0

hmax=0. 
smax=0.
bmean=0. 
accmean=0. 
ablmean=0. 
calvmean=0.  
ablbordmean=0.
bmeltmean=0.
tbmean=0.
hdotmean=0.
bdotmean=0.
volf=0.
volg=0. 
vol_shelf=0.

! 2_preparing outputs
!--------------------      
do j=1,ny
   do i=1,nx 
      
pose: if (.not.flot(i,j)) then        ! glace posee
         if (h(i,j).gt.1.) then       ! points englaces
          npg=npg+1
          volg=volg+h(i,j) 

!        nombre de points dans la zone d'ablation
         if (bm(i,j).lt.0.) nabl=nabl+1

!        calcul de la hauteur au dessus de la flottaison

         if (sealevel_2d(i,j)-B(i,j).le.0.) then    ! socle au dessus du niveau des mers
               volf=volf+h(i,j)
         else
            volf=volf+h(i,j)-row/ro*(sealevel_2d(i,j)-b(i,j))
         endif

!         recherche de l'epaisseur et surface max
         hmax=max(h(i,j),hmax)
         smax=max(s(i,j),smax) 
         bmean=bm(i,j)+bmean 
         accmean=acc(i,j)+accmean
         tbmean=tbmean+t(i,j,nz)
         vsmean=vsmean+sqrt(ux(i,j,1)**2+uy(i,j,1)**2)
         hdotmean=hdotmean+abs(hdot(i,j)) 
         bdotmean=bdotmean+abs(bdot(i,j)) 
         bmeltmean=bmeltmean+bmelt(i,j)
      endif
        calvmean=calvmean+calv(i,j)  
        ablbordmean=ablbordmean+ablbord(i,j)

     else                           ! glace flottante
        if (h(i,j).gt.1.) then       ! points englaces
           nf=nf+1
           vol_shelf=vol_shelf+H(i,j)
        end if
     end if pose


 end do
end do

! moyennes
      if (npg.ne.0) then 
        hmean=volg/npg 
        bmean=bmean/npg 
        accmean=accmean/npg 
        ablmean=bmean-accmean 
        calvmean=calvmean/npg 
        bmeltmean=bmeltmean/npg
        ablbordmean=ablbordmean/npg
        tbmean=tbmean/npg
        vsmean=vsmean/npg
        hdotmean=hdotmean/npg 
        bdotmean=bdotmean/npg
      endif 

        volg=volg*dx*dy 
        volf=volf*dx*dy
        vol_shelf=vol_shelf*dx*dy


! 2_writing outputs
!------------------    

        write(num_ritz,904)  nt,time,tafor,sealevel,         &        ! temps, forcages
                             volg,volf,vol_shelf,            &        ! volumes 5,6,7
                             npg*dx*dy,nf*dx*dy,nabl*dx*dy,  &        ! surfaces 8,9,10
                             bmean,accmean,ablmean,hdotmean, &        ! bilans 11,12
                             nint(hmean),nint(smax),         &        ! epaisseurs
                             nint(vsmean),tbmean                      ! vitesse,tbmean


904   format(i8,1x,f0.2,1x,f0.4,1x,f0.2,1x,10(es11.4,1x),3(i0,1x),f0.3)

end subroutine shortoutput
end module  output_greenmint_mod
